﻿@page "/filesPage"
@using SPAWebApp.Shared
@using SPAWebApp.Shared.Models
@using SPAWebApp.Shared.Services
@using SPAWebApp.Client.Pages.Files.Components
@using SPAWebApp.Shared.Models.Services.FileStorage
@inject Services.Contracts.IFileStorageService FileStorageService

<!-- Files Section -->
  <section class="content-files">
    @switch(state)
    { 
      case State.List:
      <!-- Controls -->
      <div class="top-menu">
        <button class="btn btn-info" title="Добавить" onclick="@(() => ChangePageState(State.Add))"><i class="fas fa-plus"></i></button>
        <button class="btn btn-info" title="Экспорт"><i class="fas fa-file-excel"></i></button>
      </div>
      <!-- End Controls -->
      <!-- Search -->
      <div class="block-search">
        <input type="search" name="search">
        <button type="button" class="btn btn-primary btn-sm btn-search"><i class="fas fa-search"></i></button>
      </div>
      <!-- End Search -->
      <!-- Files List -->
      <div id="table">
        <FilesList Files="@Files"
                   SelectedFile="@SelectFile" />
      </div>
      <!-- End Files List -->
            break;
      case State.File:
      <button class="btn btn-info" title="Назад"><i class="fas fa-arrow-circle-left" onclick="@(() => ChangeBool())"></i> </button>
      <FileInfo File="@SelectedFile" 
                FileDeleted="@(async () => await Removed())"/>
            break;
      case State.Add:
        <FileStorageAddNewFile />
        break;
        }
  </section>
<!-- End Files Section -->

@functions {
  protected List<File> Files;

  protected File SelectedFile;

  protected enum State {List, File, Add}

  State state;

  protected override async Task OnInitAsync()
  {
    Files = await FileStorageService.GetAllFilesAsync();
  }

  protected void SelectFile(File file)
  {
    Console.WriteLine(file.Id);

    SelectedFile = new File()
    {
      Id = file.Id,
      Name = file.Name,
      Size = file.Size,
      Type = file.Type,
      Comment = file.Comment
    };
    ChangePageState(State.File);
    Console.WriteLine(SelectedFile.Id);
    this.StateHasChanged();
  }

  protected void ChangeBool()
  {
    SelectedFile = null;
  }

  private void ChangePageState(State state)
  {
    this.state = state;
  }

  private async Task Removed()
  {
    Files = await FileStorageService.GetAllFilesAsync();
    ChangePageState(State.List);
    StateHasChanged();
  }
    }